#ifndef __DIALEREXT_H__
#define __DIALEREXT_H__

#include <qevent.h>
#include "dialer.h"

#define DE_DIALING  QEvent::User+10
#define DE_SLEEPING QEvent::User+11
#define DE_WAIT     QEvent::User+12

class DialerEvent: public QCustomEvent {
public:
  int timeout;
  DialerEvent( int type, int timeout0 ):
  	QCustomEvent( type ), timeout(timeout0) {}
};

class DialerExt: public Dialer  {
public:
  DialerExt( QObject *targObject, int fd );

  void cancelDialing();
  void redial();
  void increaseTimeout();
  void decreaseTimeout();
protected:
  QObject *targObject;

  virtual void dialing();
  virtual void sleeping();
  virtual void cancellingDial();
};

#endif // __DIALEREXT_H__
