#ifndef _PORTPROFILE_H_
#define _PORTPROFILE_H_

#include <termios.h>
#include <qvaluevector.h>
#include "design/portprofileui.h"

class PortProfileList;
extern PortProfileList profiles;
extern int currentPortProfile;

class PortProfile {
public:
  QString name, device, bitset;
  int speed;

  enum {
	FLOW_NONE,
	FLOW_CTSRTS,
	FLOW_XONXOFF
  };
  int flow;
};

class PortProfileList: public QValueVector<PortProfile> {
public:
  void load();
  void save();
  int speedCode( int itemPos );
};

class PortSetupUI;
class ProfileSelectorItem;

class PortProfileSelector: public PortProfileUI {
  Q_OBJECT
public:
  PortProfileSelector( QWidget *parent=0 );
  int getSelectedProfileId();
protected:
  void updateProfile( PortSetupUI *w, PortProfile *profile,
	 ProfileSelectorItem *it );
protected slots:
  void editEntry();
  void addEntry();
  void removeEntry();
};

#endif // _PORTPROFILE_H_
