#pragma once

#include <qsignal.h>
#include <dbus/qdbusconnection.h>
#include "xmodemdbusbaseinterface.h"
#include "xmodemdbusnode.h"

class XModemDBusAdapter: public QObject, public XModemDBusBase {
  Q_OBJECT
public:
  XModemDBusAdapter( QObject *targetObject, QDBusConnection connection0 ): connection(connection0) {
	connect( this, SIGNAL(rxSignal(const QString&)), targetObject, SLOT(queueRxXModem(const QString&)) );
	connect( this, SIGNAL(txSignal(const QString&)), targetObject, SLOT(queueTxXModem(const QString&)) );
  }
protected:
  QDBusConnection connection;
  bool rx( const QString& fname, QDBusError& ) { emit( rxSignal(fname) ); return true; }
  bool tx( const QString& fname, QDBusError& ) { emit( txSignal(fname) ); return true; }
  void handleMethodReply(const QDBusMessage& message) { connection.send( message ); }
signals:
  void rxSignal( const QString& fname );
  void txSignal( const QString& fname );
};

class XModemDBusNodeAdapter: public XModemDBusNode {
public:
  XModemDBusNodeAdapter( QObject *targetObject ):
	  interfaceInstance( targetObject, QDBusConnection::sessionBus() ) {

	QDBusConnection connection = QDBusConnection::sessionBus();

	registerObject( connection, "/" );
	connection.requestName( "ru.narod.vr5.term" );
  }
protected:
  XModemDBusAdapter interfaceInstance;
  QDBusObjectBase* createInterface(const QString&) { return &interfaceInstance; }
};
