// File autogenerated

// declaration include
#include "introspectableinterface.h"

// Qt includes
#include <qdom.h>
#include <qstring.h>

// Qt D-Bus includes
#include <dbus/qdbuserror.h>
#include <dbus/qdbusmessage.h>


namespace org
{
namespace freedesktop
{
namespace DBus
{

void Introspectable::buildIntrospectionData(QDomElement& interfaceElement)
{
    interfaceElement.setAttribute("name", "org.freedesktop.DBus.Introspectable");

    QDomDocument document = interfaceElement.ownerDocument();
    QDomElement methodElement = document.createElement("method");
    methodElement.setAttribute("name", "Introspect");

    QDomElement argumentElement = document.createElement("arg");
    argumentElement.setAttribute("name",      "data");
    argumentElement.setAttribute("type",      "s");
    argumentElement.setAttribute("direction", "out");
    methodElement.appendChild(argumentElement);

    interfaceElement.appendChild(methodElement);
}

QDBusMessage Introspectable::callIntrospect(const QDBusMessage& message)
{
    QDBusError   error;
    QDBusMessage reply;

    QString _data;

    if (Introspect(_data, error))
    {
        reply = QDBusMessage::methodReply(message);
        reply << QDBusData::fromString(_data);
    }
    else
    {
        if (!error.isValid())
        {
            qWarning("Call to implementation of org::freedesktop::DBus::Introspectable::Introspect returned 'false' but error object is not valid!");

            error = QDBusError::stdFailed("org.freedesktop.DBus.Introspectable.Introspect execution failed");
        }

        reply = QDBusMessage::methodError(message, error);
    }

    return reply;
}

bool Introspectable::handleMethodCall(const QDBusMessage& message)
{
    if (message.interface() != "org.freedesktop.DBus.Introspectable") return false;

    if (message.member() == "Introspect")
    {
        QDBusMessage reply = callIntrospect(message);
        handleMethodReply(reply);

        return true;
    }

    return false; 
}

}; // namespace DBus

}; // namespace freedesktop

}; // namespace org

// End of File

