#include <QApplication>
#include <QDir>
#include <QFileInfo>
#include <QDBusInterface>
#include <QDBusConnection>
#include <stdio.h>

int main( int argc, char **argv ) {
  QApplication qa(argc, argv);

  if ( argc < 2 ) {
	  puts( "./tx <filename>" );
	  return 1;
  }

  QDBusInterface xmodem( "ru.narod.vr5.Stub", "/", "ru.narod.vr5.term.xmodem" );
  if ( !xmodem.isValid() ) {
	  puts( "interface not available" );
	  return 1;
  }

  QString cmd = "tx";
  if ( QFileInfo(argv[0]).fileName() == "drx" ) cmd = "rx";

  QString fname = argv[1];
  if ( fname[0] != '/' ) fname = QDir::currentPath() + '/' + fname;

  xmodem.call( cmd, fname );
  return 0;
}
