#pragma once

#include <QDBusAbstractAdaptor>
#include <QDBusConnection>
#include <stdio.h>

class DBusXModem: public QDBusAbstractAdaptor {
  Q_OBJECT
  Q_CLASSINFO("D-Bus Interface", "ru.narod.vr5.term.xmodem")
public:
  DBusXModem( QObject *obj ): QDBusAbstractAdaptor( obj ) {
	QDBusConnection conn = QDBusConnection::sessionBus();

	if ( !conn.registerObject( "/Term", obj ) ) {
		puts( "failed to register on d-bus" );
		return;
	}

	conn.registerService( "ru.narod.vr5.Term" );
  };

public slots:
  void rx( const QString& fname ) { QMetaObject::invokeMethod( parent(), "rxFileXModem", Q_ARG(const QString&, fname) ); }
  void tx( const QString& fname ) { QMetaObject::invokeMethod( parent(), "txFileXModem", Q_ARG(const QString&, fname) ); }
};
