// File autogenerated

// declaration include
#include "xmodemdbusbaseinterface.h"

// Qt includes
#include <qdom.h>
#include <qstring.h>

// Qt D-Bus includes
#include <dbus/qdbuserror.h>
#include <dbus/qdbusmessage.h>



void XModemDBusBase::buildIntrospectionData(QDomElement& interfaceElement)
{
    interfaceElement.setAttribute("name", "ru.narod.vr5.term.xmodem");

    QDomDocument document = interfaceElement.ownerDocument();
    QDomElement methodElement = document.createElement("method");
    methodElement.setAttribute("name", "rx");

    QDomElement argumentElement = document.createElement("arg");
    argumentElement.setAttribute("name",      "fname");
    argumentElement.setAttribute("type",      "s");
    argumentElement.setAttribute("direction", "in");
    methodElement.appendChild(argumentElement);

    interfaceElement.appendChild(methodElement);

    methodElement = document.createElement("method");
    methodElement.setAttribute("name", "tx");

    argumentElement = document.createElement("arg");
    argumentElement.setAttribute("name",      "fname");
    argumentElement.setAttribute("type",      "s");
    argumentElement.setAttribute("direction", "in");
    methodElement.appendChild(argumentElement);

    interfaceElement.appendChild(methodElement);
}

QDBusMessage XModemDBusBase::callrx(const QDBusMessage& message)
{
    QDBusError   error;
    QDBusMessage reply;

    QString _fname = message[0].toString();

    if (rx(_fname, error))
    {
        reply = QDBusMessage::methodReply(message);
    }
    else
    {
        if (!error.isValid())
        {
            qWarning("Call to implementation of XModemDBusBase::rx returned 'false' but error object is not valid!");

            error = QDBusError::stdFailed("XModemDBusBase.rx execution failed");
        }

        reply = QDBusMessage::methodError(message, error);
    }

    return reply;
}

QDBusMessage XModemDBusBase::calltx(const QDBusMessage& message)
{
    QDBusError   error;
    QDBusMessage reply;

    QString _fname = message[0].toString();

    if (tx(_fname, error))
    {
        reply = QDBusMessage::methodReply(message);
    }
    else
    {
        if (!error.isValid())
        {
            qWarning("Call to implementation of XModemDBusBase::tx returned 'false' but error object is not valid!");

            error = QDBusError::stdFailed("XModemDBusBase.tx execution failed");
        }

        reply = QDBusMessage::methodError(message, error);
    }

    return reply;
}

bool XModemDBusBase::handleMethodCall(const QDBusMessage& message)
{
    if (message.interface() != "ru.narod.vr5.term.xmodem") return false;

    if (message.member() == "rx")
    {
        QDBusMessage reply = callrx(message);
        handleMethodReply(reply);

        return true;
    }

    if (message.member() == "tx")
    {
        QDBusMessage reply = calltx(message);
        handleMethodReply(reply);

        return true;
    }

    return false; 
}

// End of File

