// File autogenerated

// declaration include
#include "xmodemdbusnode.h"

// Qt includes
#include <qdom.h>
#include <qmap.h>

// Qt D-Bus includes
#include <dbus/qdbusconnection.h>
#include <dbus/qdbusmessage.h>


// interface classes includes
#include "xmodemdbusbaseinterface.h"
#include "introspectableinterface.h"


class XModemDBusNode::Private : public org::freedesktop::DBus::Introspectable
{
public:
    virtual ~Private();

public:
    QMap<QString, QDBusObjectBase*> interfaces;
    QString introspectionData;

    QDBusConnection connection;
    QString objectPath;

protected:
    virtual bool Introspect(QString& data, QDBusError& error);

    virtual void handleMethodReply(const QDBusMessage& reply);
private:
    void cacheIntrospectionData();
};

XModemDBusNode::XModemDBusNode()  : QDBusObjectBase(),
    m_private(new Private())
{
}

XModemDBusNode::~XModemDBusNode()
{
    unregisterObject();

    delete m_private;
}

bool XModemDBusNode::registerObject(const QDBusConnection& connection, const QString& path)
{
    if (path.isEmpty()) return false;

    if (!m_private->objectPath.isEmpty()) unregisterObject();

    m_private->connection = connection;
    m_private->objectPath = path;

    if (!m_private->connection.registerObject(path, this))
    {
        m_private->connection = QDBusConnection();
        m_private->objectPath = QString::null;

        return false;
    }

    if (m_private->interfaces.isEmpty())
    {
        QString name = "org.freedesktop.DBus.Introspectable";
        QDBusObjectBase* interface = m_private;
        m_private->interfaces.insert(name, interface);

        name = "ru.narod.vr5.term.xmodem";
        interface = createInterface(name);
        Q_ASSERT(interface != 0);
        m_private->interfaces.insert(name, interface);
    }

    return true;
}

void XModemDBusNode::unregisterObject()
{
    if (m_private->objectPath.isEmpty()) return;

    m_private->connection.unregisterObject(m_private->objectPath);

    m_private->connection = QDBusConnection();
    m_private->objectPath = QString::null;
}

bool XModemDBusNode::handleMethodCall(const QDBusMessage& message)
{
    QMap<QString, QDBusObjectBase*>::iterator findIt = m_private->interfaces.find(message.interface());
    if (findIt == m_private->interfaces.end()) return false;

    return delegateMethodCall(message, findIt.data());
}

XModemDBusNode::Private::~Private()
{
    QMap<QString, QDBusObjectBase*>::const_iterator it    = interfaces.begin();
    QMap<QString, QDBusObjectBase*>::const_iterator endIt = interfaces.end();
    for (; it != endIt; ++it)
    {
        QDBusObjectBase* interface = it.data();
        if (interface != this)
            delete interface;
    }
    interfaces.clear();
}

bool XModemDBusNode::Private::Introspect(QString& data, QDBusError& error)
{
    Q_UNUSED(error);
    if (introspectionData.isEmpty()) cacheIntrospectionData();

    data = introspectionData;

    return true;
}

void XModemDBusNode::Private::handleMethodReply(const QDBusMessage& reply)
{
    connection.send(reply);
}

void XModemDBusNode::Private::cacheIntrospectionData()
{
    QDomDocument doc;
    QDomElement nodeElement = doc.createElement("node");
    QDomElement interfaceElement = doc.createElement("interface");
    org::freedesktop::DBus::Introspectable::buildIntrospectionData(interfaceElement);
    nodeElement.appendChild(interfaceElement);

    interfaceElement = doc.createElement("interface");
    ::XModemDBusBase::buildIntrospectionData(interfaceElement);
    nodeElement.appendChild(interfaceElement);

    doc.appendChild(nodeElement);

    introspectionData = "<!DOCTYPE node PUBLIC \"-//freedesktop//DTD D-BUS Object Introspection 1.0//EN\"\n\"http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd\">\n";
    introspectionData += doc.toString();
}

// End of File

