#ifndef __TRANSFERDIALOG_H__
#define __TRANSFERDIALOG_H__

#include <stdlib.h>
#include "design/transferui.h"

#define XFER_FILE_INFO    QEvent::User
#define XFER_FILE_RESUME  QEvent::User+1
#define XFER_FILE_DATA    QEvent::User+2
#define XFER_FILE_DONE    QEvent::User+3
#define XFER_SESSION_TERM QEvent::User+4

class XferEvent: public QEvent {
public:
  char *fname;
  int bytes;

  XferEvent( int type ): QEvent( (QEvent::Type)type ),  fname(0), bytes(0) {}
  ~XferEvent() { free( fname ); }
};

class TransferDialog: public TransferUI {
  Q_OBJECT
public:
  TransferDialog( QWidget *parent );
protected:
  bool emitDoneEnabled;
  
  QTimer *xferInfoTimer;
  time_t transferStartTime;
  int xferFileSize, xferStartPos, xferTransferredBytes;

  virtual void customEvent( QCustomEvent *e );
  virtual void reject() { cancelXfer(); }
protected slots:
  void updateXferInfo();
  void cancelXfer();
signals:
  void fileTransferStart( XferEvent *e );
  void fileTransferResume( XferEvent *e );
  void fileTransferDone();
  void skipFileRequested();
  void cancelSessionRequested();
};

#endif // __TRANSFERDIALOG_H__
