#ifndef _ZMODEM_H_
#define _ZMODEM_H_

class ZModem {
public:
  int cmdPipe[2];
  char *dlpath;

  ZModem( int read_fd, int write_fd );
  virtual ~ZModem();
  void sendFiles( char **flist );
  void receiveFiles( bool skip_state0 );
protected:
  int read_fd, write_fd;
  int zdle_count;
  bool reverse_crc, crc32Mode, foundHdr32, remoteHasZMCRC;

  int readFromLine( char *buf, int len, int timeout = -1 );
  void putHexHdr( int type, char *data );
  void putHexHdr( int type );
  void zdleWrite( char *data, int len );
  void putBin16Hdr( int type, char *data );
  void putBin32Hdr( int type, char *data );
  void putBinHdr( int type, char *data );
  void putBinHdr( int type );
  void putData16( char *data, int len, int endtype );
  void putData32( char *data, int len, int endtype );
  void putData( char *data, int len, int endtype );
  int getXByte( char *s );
  int getHdr( int& type, char *data, bool wait, int timeout = -1 );
  bool isZCancel( char c );
  int getData( char *data, int& len, int& endtype, int pos );
  bool dataAvail();
  int putZFile( int& f, char *fname );
  int getFileCrc( int fd, int len );
  int zrCheckCrc( int fd, int len );
  int startZReceive( char *fname, int& f, int& pos, int& mtime );
  int recvFileData( int f, int& pos );
  void zrCloseFile( int f, char *fname, int mtime );
  int skipFile();
  void cancelSession();

  virtual void feFileInfo( char *fname, int bytes ) {}
  virtual void feFileResume( int startPos ) {}
  virtual void feFileData( int bytes ) {}
  virtual void feFileDone() {}

  virtual void transferCancelled() {}
  virtual bool stopRxRequested() { return false; }
};

#endif // _ZMODEM_H_
